#include "DeviceList.h"
#include "EventID.h"
#include "NativeSignAPI.h"
#include <string>
#include <limits.h>
#include <iostream>
#include <vector>


wxComboBox *DevFoundComboBox;
wxComboBox *DevComboBox;
wxFrame *ParentFrame;
//wxStatusBar *StatusBar;// = new wxStatusBar();
DeviceList::DeviceList(const wxString & title, wxFrame *parentFrame) : wxDialog(NULL, -1, title, wxDefaultPosition, wxSize(300, 200))
{
	ParentFrame = parentFrame;
	filelist = new wxListBox(this, wxEVT_LEFT_DCLICK, wxDefaultPosition, wxSize(300, 200));
	filelist->Bind(wxEVT_LEFT_DCLICK , &DeviceList::OnfilelistMouseLeftDClk, this, wxID_ANY);
	std::vector<std::string> devices = NativeSignAPI::EnumerateDevicesFilter(0);
	filelist->Clear();
	if (devices.size() > 0) 
	{
		for (int k = 0; k < devices.size(); k++) 
			filelist->AppendString(devices[k]);
		
	}
	Centre();
	ShowModal();
	Destroy(); 
}

void DeviceList::OnfilelistMouseLeftDClk(wxMouseEvent& event)
{
	char SelectedFileName[1024];
	strncpy(SelectedFileName, (const char*)filelist->GetString(filelist->GetSelection()).mb_str(wxConvUTF8), 1023);
	if(!NativeSignAPI::SetDevice(SelectedFileName))
		ParentFrame->SetStatusText("Connected Device :" + filelist->GetString(filelist->GetSelection()));
	else
		ParentFrame->SetStatusText("connection to Device failed");
	Destroy();	
}

void DeviceList::OnSetDeviceButton(wxCommandEvent& event)
{
}

