#include "ImagePanel.h"
#include <wx/dcclient.h>
#include <wx/graphics.h>



wxImagePanel::wxImagePanel(wxFrame* parent, wxPanel* panel, wxSize size) :
wxPanel(parent)
{
    // load the file... ideally add a check to see if loading was successful
    //image = bmp;
    Panel = panel;
    this->SetSize(size);
    Bind(wxEVT_PAINT, &wxImagePanel::paintEvent, this, wxID_ANY);
}

/*
 * Called by the system of by wxWidgets when the panel needs
 * to be redrawn. You can also trigger this call by
 * calling Refresh()/Update().
 */

void wxImagePanel::paintEvent(wxPaintEvent & evt)
{

    // depending on your system you may need to look at double-buffered dcs
    wxClientDC dc(this);
    wxGraphicsContext* gc = wxGraphicsContext::Create(dc);
    if (gc)
    {
        //gc->DrawBitmap(image, 0, 0, 600, 400);
       /* wxImage* m_pOldImg = new wxImage( "myfile.bmp", wxBITMAP_TYPE_BMP, -1 );

        int dataSize = m_pOldImg->GetWidth() * m_pOldImg->GetHeight() * 3;
        unsigned char* NewImgData = ( unsigned char* ) malloc( dataSize );
        unsigned char* OldImgData = m_pOldImg->GetData();

        memcpy( NewImgData, OldImgData, dataSize );

        wxImage* m_pNewImg = new wxImage( m_pOldImg->GetWidth(), m_pOldImg->GetHeight(), NewImgData );
        wxBitmap* TpBmp = new wxBitmap(*m_pNewImg);

        //gc->CreateBitmapFromImage(*m_pNewImg);
        gc->DrawBitmap(*TpBmp, 0, 0, 600, 400);
        /*gc->SetPen(*wxGREY_PEN);
        gc->SetBrush(*wxLIGHT_GREY_BRUSH);
        gc->DrawRectangle(10, 10, 50, 50);
        gc->DrawEllipse(70, 10, 50, 50);*/
        if(ReloadedImage.IsOk())
        {
            gc->DrawBitmap(ReloadedImage, 0, 0, ReloadedImage.GetWidth(), ReloadedImage.GetHeight());
        }
        delete gc;
    }
    //render(dc);
 }
    

/*
 * Alternatively, you can use a clientDC to paint on the panel
 * at any time. Using this generally does not free you from
 * catching paint events, since it is possible that e.g. the window
 * manager throws away your drawing when the window comes to the
 * background, and expects you will redraw it when the window comes
 * back (by sending a paint event).
 */
void wxImagePanel::paintNow(wxImage image)
{
   // depending on your system you may need to look at double-buffered dcs
    wxClientDC dc(this);
    ReloadedImage = image;
    wxGraphicsContext* gc = wxGraphicsContext::Create(dc);
    if (gc)
    {
        gc->DrawBitmap(image, 0, 0, image.GetWidth(), image.GetHeight());
        delete gc;
    }
}

void wxImagePanel::paintRectNow(int x, int y, int width, int height)
{
   // depending on your system you may need to look at double-buffered dcs
    wxClientDC dc(this);
    wxGraphicsContext* gc = wxGraphicsContext::Create(dc);
    if (gc)
    {
        gc->DrawBitmap(ReloadedImage, 0, 0, ReloadedImage.GetWidth(), ReloadedImage.GetHeight());
        wxPen *pen = new wxPen(wxColor("Red"), 1, wxPENSTYLE_SOLID);
        gc->SetPen(*pen);
        gc->DrawRectangle(x, y, width , height);
        delete gc;
    }
}

/*
 * Here we do the actual rendering. I put it in a separate
 * method so that it can work no matter what type of DC
 * (e.g. wxPaintDC or wxClientDC) is used.
 */
void wxImagePanel::render(wxDC&  dc)
{
    dc.DrawBitmap( image, 0, 0, false );
}



