
#pragma once
#ifdef _WIN32
#include <Windows.h>
#elif __APPLE__
#elif __linux__
#endif

#include <vector>
#include <string>



enum ImageSizeOption
{
	None = 0,
	crop,
	stretch,
	reserved,
	keepAspectRatio,
	reserved1,
	reserved2,
	reserved3,
	embedIntoSignBackground,
};

class NativeSignAPI
{
public:
	static void *NativeSignAPIAPIobj;
	static bool IsDeviceSet ;
	static bool load_library();
  
  
	static void* load_library(const char* path);
	static intptr_t get_export(void* h, const char* name);
	static int Free(intptr_t* ptr);
	static int FreeAll();

	static std::vector<std::string> EnumerateDevicesFilter(unsigned int filter);
	static int SetDevice(std::string device);
	static int LoadPdf(char* path);
	static char*  loadLengthPrefixedOctetsFromPath(const char* path);
	static int GetNumberOfPages();
	static intptr_t RenderPageWithDpiAsPng(int32_t page, int32_t dpi);
	static int32_t SetDocumentViewing(intptr_t image, int32_t pageNumber, int32_t numberOfPages);
	static int32_t ViewDocument(int32_t pageNumber, int32_t zoomLevel, int32_t startSignatureButtonEnabled);
	static int32_t AddSignatureField(intptr_t fieldName, double row0, double column0, double row1, double column1, int32_t pageNumber);
	static intptr_t** GetAcroFormFields();
	static intptr_t GetFieldName(intptr_t fieldHandle);
	static int32_t GetFieldIsSignatureField(intptr_t fieldHandle);
	static int32_t SignSignatureField(intptr_t signatureField, intptr_t signatureInfo, intptr_t behaviour);
	static intptr_t GetBehaviourDefault(void);
	static int32_t SetBehaviourSignInDocument(intptr_t behaviour, intptr_t docSignRectangle, int32_t crop);
	static intptr_t GetDocSignRectangleFromTopLeftAndZoomLevel(int32_t top, int32_t left, int32_t zoomLevel);
	static int32_t SetButtonCallback(/* void( *)(intptr_t) */ intptr_t fptr);
	static intptr_t DownloadPdf(void);
	static int32_t DialogCreate(int32_t pageNumber);
	static int32_t DialogStartSignature(intptr_t path, int32_t scrollToSignature);
	static intptr_t DialogSave(intptr_t path);
  
	NativeSignAPI()
	{
		IsDeviceSet = false;
	}

};

