#include "main.h"
#include "NativeSignAPI.h"
#include "DeviceList.h"




wxPanel *panel;
wxImagePanel * drawPane;
//char full[_MAX_PATH];
bool Finish_Signature = true;
std::unique_ptr<std::thread> thread_ptr;
wxStatusBar *statusBar;
wxBitmap* TpBmp;
static MyFrame *frameobj;

bool MyApp::OnInit()
{
    MyFrame *frame = new MyFrame();
    frame->SetSize(5, 5, 670, 1015, wxSIZE_FORCE);
    frame->SetMinSize(wxSize(670, 1015));
    frame->SetMaxSize(wxSize(670, 1015));
    frameobj = frame;
    //frame->SetBackgroundColour(*wxWHITE);
    wxBoxSizer* sizer = new wxBoxSizer(wxHORIZONTAL);    
    
    frame->Show(true);
    if( !NativeSignAPI::load_library() )
        wxMessageBox("Lib failed to load");

    wxInitAllImageHandlers();    
    return true;
}


MyFrame::MyFrame()    : wxFrame(NULL, wxID_ANY, "Sign API Native Example Application")
{
    MyFrame::FirstMouseDown = 0;
    MyFrame::FirstMouseX = 0;
    MyFrame::FirstMouseY = 0;
    MyFrame::MouseX = 0;
    MyFrame::MouseY = 0;
    MyFrame::SignatureRectangleWidth = 0;
    MyFrame::SignatureRectangleHeight = 0;
    DrawSignatureRectangle = false;
    DrawSignatureRectangleAndStartSignMode = false;
    IsPdfClientSet = false;
    PadInDialogMode = false;



    wxBoxSizer *vbox = new wxBoxSizer(wxVERTICAL);
    wxBoxSizer *vbox1 = new wxBoxSizer(wxVERTICAL);
    wxBoxSizer *hbox = new wxBoxSizer(wxHORIZONTAL);
    wxBoxSizer *hbox1 = new wxBoxSizer(wxHORIZONTAL);

    // ----------- Create FileMenu ------------------------------------------------------
    wxMenu *menuFile = new wxMenu;
    menuFile->Append(ID_LoadDocument, "&LoadDocument", "Load Document");
    Bind(wxEVT_MENU, &MyFrame::OnLoadDocument, this, ID_LoadDocument);
    menuFile->AppendSeparator();
    menuFile->Append(ID_SaveDocument, "&SaveDocument", "Save Document");
    Bind(wxEVT_MENU, &MyFrame::OnSaveDocument, this, ID_SaveDocument);
    menuFile->AppendSeparator();
    menuFile->Append(wxID_EXIT);

    // ----------- Create SettingsMenu ------------------------------------------------------
    menuSettings = new wxMenu;
    
    DPI_SubMenu = new wxMenu;
    DPI_SubMenu->AppendCheckItem(ID_72CheckedItem, "72", "&DPI_72 = Sets 72 as DPI");
    Bind(wxEVT_MENU, &MyFrame::OnDPI72, this, ID_72CheckedItem);
    DPI_SubMenu->AppendSeparator();
    DPI_SubMenu->AppendCheckItem(ID_96CheckedItem, "96", "&DPI_96 = Sets 96 as DPI");
    Bind(wxEVT_MENU, &MyFrame::OnDPI96, this, ID_96CheckedItem);
    DPI_SubMenu->AppendSeparator();
    DPI_SubMenu->AppendCheckItem(ID_150CheckedItem, "150", "&DPI_150 = Sets 150 as DPI");
    Bind(wxEVT_MENU, &MyFrame::OnDPI150, this, ID_150CheckedItem);
    DPI_SubMenu->AppendSeparator();
    DPI_SubMenu->AppendCheckItem(ID_300CheckedItem, "300", "&DPI_300 = Sets 300 as DPI");
    Bind(wxEVT_MENU, &MyFrame::OnDPI300, this, ID_300CheckedItem);
    DPI_SubMenu->AppendSeparator();
    wxMenu **menu = NULL;
    wxMenuItem* CheckedItemDPI72 = DPI_SubMenu->FindItem(ID_72CheckedItem, menu);
    CheckedItemDPI72->Check(true);
    menuSettings->AppendSubMenu(DPI_SubMenu, "DPI");
    menuSettings->AppendCheckItem(ID_AskForName, "Prompt for Name while Signing");
    FirstMouseDown = false;
    
    // ----------- Create ModesMenu ------------------------------------------------------
    wxMenu *ModesMenu = new wxMenu;
    ModesMenu->Append(ID_ViewDocument, "&View Document", "Current Page is shown on the Pad");
    Bind(wxEVT_MENU , &MyFrame::OnViewDocument, this, ID_ViewDocument);

    ModesMenu->Append(ID_AddSignRect, "&Add Signature Rectangle", "on the current page Signature rectangle is added but signature mode is not started");
    Bind(wxEVT_MENU , &MyFrame::OnAddSignRect, this, ID_AddSignRect);

    ModesMenu->Append(ID_AddSignRectandStartSignMode, "&Add Signature Rectangle and StartSignature Mode", "Adds Signature Rectangle and starts siganture mode");
    Bind(wxEVT_MENU , &MyFrame::OnAddSignRectandStartSignMode, this, ID_AddSignRectandStartSignMode);

    ModesMenu->Append(ID_LoadDialogModeElements, "&DialogMode Elements", "allows you to modify elements in pdf");
    Bind(wxEVT_MENU , &MyFrame::OnLoadDialogModeElements, this, ID_LoadDialogModeElements);

    ModesMenu->Append(ID_LoadDialogModeSignature, "&DialogMode Signature", "allows you to sign after elents have been saved pdf");
    Bind(wxEVT_MENU , &MyFrame::OnLoadDialogModeSignature, this, ID_LoadDialogModeSignature);
   
    
    // ----------- Create HelpMenu ------------------------------------------------------
    wxMenu *menuHelp = new wxMenu;
    menuHelp->Append(wxID_ABOUT);

    //------------- Create Menubar -------------------------------------------------------------------------
    wxMenuBar *menuBar = new wxMenuBar;
    menuBar->Append(menuFile, "&File");
    menuBar->Append(menuSettings, "&Settings");
    menuBar->Append(ModesMenu, "&Modes");
    menuBar->Append(menuHelp, "&Help");
    SetMenuBar( menuBar );

    //------------------------- create status bar ----------------------------------------------------------------------------
    statusBar = CreateStatusBar();   
    SetStatusText("Pad Not connected");

    //---------- create Button ------------------------------------------------------------------
    panel = new wxPanel(this, wxID_ANY , wxDefaultPosition, wxSize(630, 891));
    panel->Bind(wxEVT_LEFT_DOWN , &MyFrame::OnPanelMouseLeftDn, this, wxID_ANY);
    panel->Bind(wxEVT_LEFT_UP, &MyFrame::OnPanelMouseLeftUp, this, wxID_ANY);
    panel->Bind(wxEVT_MOTION, &MyFrame::OnLoadLicenseMouseMove, this, wxID_ANY);
    panel->SetBackgroundColour(wxT("wxWHITE"));
    TpBmp = new wxBitmap(630, 891);
    drawPane = new wxImagePanel(this, panel, wxSize(630, 891));
    //wxPanel *panel3 = new wxPanel(this, wxID_ANY , wxDefaultPosition, wxSize(40, 891));
    Loglist = new wxListBox(this, ID_Loglist, wxDefaultPosition, wxSize(600, 124));
    CurPageNoTxt = new wxTextCtrl(this, -1, "0",  wxDefaultPosition, wxSize(60, 20));
    MaxPageNoTxt = new wxTextCtrl(this, -1, "0",  wxDefaultPosition, wxSize(60, 20));
    vbox1->Add(CurPageNoTxt, 1, wxLEFT, 0);
    vbox1->Add(MaxPageNoTxt, 1, wxLEFT, 0);
    hbox1->Add(Loglist, 1, wxLEFT, 0);
    hbox1->Add(vbox1, 1, wxLEFT, 0);
      
    wxPanel *panel2 = new wxPanel(this, wxID_ANY , wxDefaultPosition, wxSize(40, 891));
    scrollbar = new wxScrollBar(panel2, ID_ScrollBarUpdated, wxPoint(0, 0), wxSize(20, 891), wxSB_VERTICAL);
    scrollbar->Bind(wxEVT_SCROLL_CHANGED, &MyFrame::OnScrollBarUpdated, this, ID_ScrollBarUpdated);
    scrollbar->SetRange(500);
    hbox->Add(panel, 1, wxLEFT, 0);
    hbox->Add(panel2, 1, wxLEFT, 0);
    vbox->Add(hbox, 1, wxLEFT, 0);
    vbox->Add(hbox1, 1, wxLEFT, 0);

    SetSizer(vbox);
    Bind(wxEVT_MENU, &MyFrame::OnExit, this, wxID_EXIT);
    Bind(wxEVT_CLOSE_WINDOW, &MyFrame::OnCloseWindow, this, -1);
}



//-------------- FileMenu Callbacks ------------------------------------------------------------------------------------------------
void MyFrame::OnLoadDocument(wxCommandEvent& event)
{
    Loglist->Clear();
    if(!SelectDevice())
     return;
   
    if(0 ==  NativeSignAPI::SetButtonCallback((intptr_t)(MyFrame::onButtonEvents)))
    {
        Loglist->Append("SetButtonCallback successful");
        Loglist->SetSelection(Loglist->GetCount() - 1);
    }
    else
    {
        Loglist->Append("SetButtonCallback failed");
        Loglist->SetSelection(Loglist->GetCount() - 1);
        return;
    }
    
    Loglist->Append("Attempting to load pdf");
    wxFileDialog *OpenDialog = new wxFileDialog(this, _("Choose a file to open"), wxEmptyString, wxEmptyString,_("PDF files (*.pdf)|*.pdf|ALL files (*.*)|*.*"),	wxFD_OPEN, wxDefaultPosition);
    
    char Pdfpath[1023];
	// Creates a "open file" dialog with image file types
	if (OpenDialog->ShowModal() == wxID_OK) // if the user click "Open" instead of "cancel"
	{
		wxString CurrentDocPath = OpenDialog->GetPath();
        Location = OpenDialog->GetDirectory();
        std::string stlstring = std::string(CurrentDocPath.mb_str());  
        strcpy(Pdfpath, (const char*)stlstring.c_str());
        int error = NativeSignAPI::LoadPdf((char*) Pdfpath);
        if(error != 0)
        {
            Loglist->Append("error Loading Pdf. Check logs for errors");
            Loglist->SetSelection(Loglist->GetCount() - 1);
            IsPdfClientSet = false;
            return;
        }
        IsPdfClientSet = true;
        Loglist->Append("Loaded Pdf Successfully");
        Loglist->SetSelection(Loglist->GetCount() - 1);

        CurrentPageNo = 0;
        MaxPageNo = NativeSignAPI::GetNumberOfPages();
        CurPageNoTxt->SetLabel("1");
        MaxPageNoTxt->SetLabel(std::to_string(MaxPageNo));
        scrollbar->SetRange(MaxPageNo);

        intptr_t ImagePtr = NativeSignAPI::RenderPageWithDpiAsPng(CurrentPageNo  , GetDPI());
        if(ImagePtr == 0 | ImagePtr == NULL){
            Loglist->Append("RenderPageWithDpiAsPng failed");
            Loglist->SetSelection(Loglist->GetCount() - 1);
            return ;
        }

        intptr_t* l = (intptr_t*)ImagePtr;
        int32_t dataSize = l[0];
        const void* s = (char *)(ImagePtr + 4);
        wxMemoryInputStream mis(s, (size_t)l);
        wxImage myImage(mis, wxBITMAP_TYPE_ANY, -1);
        myImage.Rescale(630, 891, wxIMAGE_QUALITY_HIGH);
        wxASSERT(myImage.Ok());
        //myImage = ExchangeRGB_BGR(myImage);
        drawPane->paintNow(myImage); 
        NativeSignAPI::Free((intptr_t *)ImagePtr);
	}

}

void MyFrame::DrawCurrentImagetoGUI()
{
    intptr_t ImagePtr = NativeSignAPI::RenderPageWithDpiAsPng(CurrentPageNo  , GetDPI());

        intptr_t* l = (intptr_t*)ImagePtr;
        int32_t dataSize = l[0];
        const void* s = (char *)(ImagePtr + 4);
        wxMemoryInputStream mis(s, (size_t)l);
        wxImage myImage(mis, wxBITMAP_TYPE_ANY, -1);
        myImage.Rescale(630, 891, wxIMAGE_QUALITY_HIGH);
        wxASSERT(myImage.Ok());
        //myImage = ExchangeRGB_BGR(myImage);
        drawPane->paintNow(myImage); 
        NativeSignAPI::Free((intptr_t *)ImagePtr);
}



void MyFrame::OnSaveDocument(wxCommandEvent& event)
{
    int error = -1;

    char* Pdfpath;
    std::string stlstring = std::string(Location.mb_str());  
    strcpy(Pdfpath, (const char*)stlstring.c_str());
    if(PadInDialogMode)
        error = NativeSignAPI::DialogSave((intptr_t )Pdfpath);
    else
        error = NativeSignAPI::DownloadPdf();
    if(0 == error)
        Loglist->Append("SaveDocument successful");
    else
        Loglist->Append("SaveDocument failed");

    Loglist->SetSelection(Loglist->GetCount() - 1);
}

void MyFrame::OnExit(wxCommandEvent& event)
{
    Close(true);
}
void MyFrame::OnCloseWindow(wxCloseEvent&  event)
{
    int error = NativeSignAPI::FreeAll();
    Destroy();
}

struct buttonEvent
{
    int32_t kind;
};

void MyFrame::onButtonEvents(intptr_t* rxptr)
{
    buttonEvent *be = (buttonEvent*)rxptr;
    if(be->kind == buttonkind::startSignature &&  frameobj->DrawSignatureRectangle)
    {
        frameobj->DrawSignatureRectangle = false;
        frameobj->StartSigning();
        frameobj->ViewDocument();
        frameobj->DrawCurrentImagetoGUI();
    }
}

//------------------------------------------------------------------------------------------------------------------------------------

//-------------- panel Mouse Callbacks ---------------------------------------------------------------------------------------

void MyFrame::OnPanelMouseLeftDn(wxMouseEvent& event)
{
    if(DrawSignatureRectangle|| DrawSignatureRectangleAndStartSignMode)
    {
        event.GetPosition(&FirstMouseX, &FirstMouseY);
        FirstMouseDown = true;
    }
    
}

void MyFrame::OnPanelMouseLeftUp(wxMouseEvent& event)
{
    if(!FirstMouseDown)
        return;
    int X, Y;
    event.GetPosition(&X, &Y);

    SignatureRectangleWidth = X - FirstMouseX ;
    SignatureRectangleHeight = Y - FirstMouseY;
    FirstMouseDown = false;

    
    // draw signature rect

    if(0 == NativeSignAPI::AddSignatureField((intptr_t)("SignatureFiled1"), FirstMouseY, FirstMouseX, Y, X, CurrentPageNo))
        Loglist->Append("Added SignatureFiled1 to Pdf");
    else
        Loglist->Append("Unable to add SignatureFiled1 to Pdf");

    Loglist->SetSelection(Loglist->GetCount() - 1);
    if(DrawSignatureRectangleAndStartSignMode)
    {
        StartSigning();
        ViewDocument();
        DrawCurrentImagetoGUI();
    }
    
    if(DrawSignatureRectangle)
    {
       ViewDocument();
    }

    
    DrawSignatureRectangleAndStartSignMode = false;
}

void MyFrame::OnLoadLicenseMouseMove(wxMouseEvent& event)
{
    if(!FirstMouseDown)
        return;
    int X, Y;
    event.GetPosition(&X, &Y);
    
    //drawPane->ClearBackground();
    drawPane->paintRectNow(FirstMouseX, FirstMouseY, X - FirstMouseX , Y - FirstMouseY);
}
//-------------- Settings DPI_Submenu Callbacks ---------------------------------------------------------------------------------------

void MyFrame::OnDPI72(wxCommandEvent& event)
{
    wxMenu **menu = NULL;
    wxMenuItem* CheckedItemDPI72 = DPI_SubMenu->FindItem(ID_72CheckedItem, menu);
    wxMenuItem* CheckedItemDPI96 = DPI_SubMenu->FindItem(ID_96CheckedItem, menu);
    wxMenuItem* CheckedItemDPI150 = DPI_SubMenu->FindItem(ID_150CheckedItem, menu);
    wxMenuItem* CheckedItemDPI300 = DPI_SubMenu->FindItem(ID_300CheckedItem, menu);

    if(CheckedItemDPI72->IsChecked())
    {
        //CheckedItemDPI72->Check(false);
        CheckedItemDPI96->Check(false);
        CheckedItemDPI150->Check(false);
        CheckedItemDPI300->Check(false);
    }

    if(!CheckedItemDPI72->IsChecked() && !CheckedItemDPI96->IsChecked() && !CheckedItemDPI150->IsChecked() && !CheckedItemDPI300->IsChecked())
        CheckedItemDPI72->Check(true);
}

void MyFrame::OnDPI96(wxCommandEvent& event)
{
    wxMenu **menu = NULL;
    wxMenuItem* CheckedItemDPI72 = DPI_SubMenu->FindItem(ID_72CheckedItem, menu);
    wxMenuItem* CheckedItemDPI96 = DPI_SubMenu->FindItem(ID_96CheckedItem, menu);
    wxMenuItem* CheckedItemDPI150 = DPI_SubMenu->FindItem(ID_150CheckedItem, menu);
    wxMenuItem* CheckedItemDPI300 = DPI_SubMenu->FindItem(ID_300CheckedItem, menu);

    if(CheckedItemDPI96->IsChecked())
    {
        CheckedItemDPI72->Check(false);
        //CheckedItemDPI96->Check(false);
        CheckedItemDPI150->Check(false);
        CheckedItemDPI300->Check(false);
    }

    if(!CheckedItemDPI72->IsChecked() && !CheckedItemDPI96->IsChecked() && !CheckedItemDPI150->IsChecked() && !CheckedItemDPI300->IsChecked())
        CheckedItemDPI72->Check(true);
}

void MyFrame::OnDPI150(wxCommandEvent& event)
{
    wxMenu **menu = NULL;
    wxMenuItem* CheckedItemDPI72 = DPI_SubMenu->FindItem(ID_72CheckedItem, menu);
    wxMenuItem* CheckedItemDPI96 = DPI_SubMenu->FindItem(ID_96CheckedItem, menu);
    wxMenuItem* CheckedItemDPI150 = DPI_SubMenu->FindItem(ID_150CheckedItem, menu);
    wxMenuItem* CheckedItemDPI300 = DPI_SubMenu->FindItem(ID_300CheckedItem, menu);

    if(CheckedItemDPI150->IsChecked())
    {
        CheckedItemDPI72->Check(false);
        CheckedItemDPI96->Check(false);
        //CheckedItemDPI150->Check(false);
        CheckedItemDPI300->Check(false);
    }

    if(!CheckedItemDPI72->IsChecked() && !CheckedItemDPI96->IsChecked() && !CheckedItemDPI150->IsChecked() && !CheckedItemDPI300->IsChecked())
        CheckedItemDPI72->Check(true);
}

void MyFrame::OnDPI300(wxCommandEvent& event)
{
    wxMenu **menu = NULL;
    wxMenuItem* CheckedItemDPI72 = DPI_SubMenu->FindItem(ID_72CheckedItem, menu);
    wxMenuItem* CheckedItemDPI96 = DPI_SubMenu->FindItem(ID_96CheckedItem, menu);
    wxMenuItem* CheckedItemDPI150 = DPI_SubMenu->FindItem(ID_150CheckedItem, menu);
    wxMenuItem* CheckedItemDPI300 = DPI_SubMenu->FindItem(ID_300CheckedItem, menu);

    if(CheckedItemDPI300->IsChecked())
    {
        CheckedItemDPI72->Check(false);
        CheckedItemDPI96->Check(false);
        CheckedItemDPI150->Check(false);
        //CheckedItemDPI300->Check(false);
    }

    if(!CheckedItemDPI72->IsChecked() && !CheckedItemDPI96->IsChecked() && !CheckedItemDPI150->IsChecked() && !CheckedItemDPI300->IsChecked())
        CheckedItemDPI72->Check(true);
}

int MyFrame::GetDPI()
{
    wxMenu **menu = NULL;
    wxMenuItem* CheckedItemDPI72 = DPI_SubMenu->FindItem(ID_72CheckedItem, menu);
    wxMenuItem* CheckedItemDPI96 = DPI_SubMenu->FindItem(ID_96CheckedItem, menu);
    wxMenuItem* CheckedItemDPI150 = DPI_SubMenu->FindItem(ID_150CheckedItem, menu);
    wxMenuItem* CheckedItemDPI300 = DPI_SubMenu->FindItem(ID_300CheckedItem, menu);
    if(CheckedItemDPI72->IsChecked())
        return 72;
    else if(CheckedItemDPI96->IsChecked())
        return 96;
    else if(CheckedItemDPI150->IsChecked())
        return 150;
    else 
        return 300;
}
//------------------------------------------------------------------------------------------------------------------------------------




bool MyFrame::SelectDevice()
{
    if(NativeSignAPI::IsDeviceSet)
        return true;
    DeviceList *DevList = new DeviceList(wxT("Select Device"), this);
    DevList->Show(true);
    std::this_thread::sleep_for(std::chrono::milliseconds(1000));

    if(!NativeSignAPI::IsDeviceSet)
    {
        Loglist->Append("Unable to establish connection with Device");   
        Loglist->SetSelection(Loglist->GetCount() - 1);
        return false;
    }


    Loglist->Append("Successfully connected to Device");   
    Loglist->SetSelection(Loglist->GetCount() - 1);
    return true;
}


//-------------- ScrollBarUpdate Callbacks ---------------------------------------------------------------------------------------
void MyFrame::OnScrollBarUpdated(wxCommandEvent& event)
{
    if(!IsPdfClientSet){wxLogMessage("No Pdf is Loaded"); return;}
    CurrentPageNo = event.GetInt();

    intptr_t ImagePtr = NativeSignAPI::RenderPageWithDpiAsPng(CurrentPageNo , GetDPI());

    intptr_t* l = (intptr_t*)ImagePtr;
    int32_t dataSize = l[0];
    const void* s = (char *)(ImagePtr + 4);
    wxMemoryInputStream mis(s, (size_t)l);
    wxImage myImage(mis, wxBITMAP_TYPE_ANY, -1);
    myImage.Rescale(630, 891, wxIMAGE_QUALITY_HIGH);
    wxASSERT(myImage.Ok());
    drawPane->paintNow(myImage); 
    CurPageNoTxt->SetLabel(std::to_string(CurrentPageNo + 1));
    NativeSignAPI::Free((intptr_t *)ImagePtr);
}
//------------------------------------------------------------------------------------------------------------------------------------

//-------------- ModeMenu Callbacks ---------------------------------------------------------------------------------------
void MyFrame::OnViewDocument(wxCommandEvent& event)
{
    ViewDocument();
}

void MyFrame::ViewDocument()
{
    if(!IsPdfClientSet){wxLogMessage("No Pdf is Loaded"); return;}
    Loglist->Append("ViewDocument is Requested");
    //intptr_t ImagePtr = NativeSignAPI::RenderPageWithDpiAsPng(CurrentPageNo , GetDPI());
    if( 0 == NativeSignAPI::ViewDocument(CurrentPageNo, 2, 1))
    {
        Loglist->Append("ViewDocument is Successful");
        PadInDialogMode = false;
    }       
    else
        Loglist->Append("ViewDocument Failed, Check Logs");
    Loglist->SetSelection(Loglist->GetCount() - 1);
}
void MyFrame::OnAddSignRect(wxCommandEvent& event)
{
     if(!IsPdfClientSet){wxLogMessage("No Pdf is Loaded"); return;}
     DrawSignatureRectangle = true;
}
void MyFrame::OnAddSignRectandStartSignMode(wxCommandEvent& event)
{
     if(!IsPdfClientSet){wxLogMessage("No Pdf is Loaded"); return;}
     DrawSignatureRectangleAndStartSignMode = true;
}
void MyFrame::OnLoadDialogModeElements(wxCommandEvent& event)
{
     if(!IsPdfClientSet){wxLogMessage("No Pdf is Loaded"); return;}

     if(0 == NativeSignAPI::DialogCreate(1))
     {
         Loglist->Append("DialogCreate is Successful");
         PadInDialogMode = true;
     }
     else
     {
         Loglist->Append("DialogCreate failed");
     }
     Loglist->SetSelection(Loglist->GetCount() - 1);
}
void MyFrame::OnLoadDialogModeSignature(wxCommandEvent& event)
{
    if(!IsPdfClientSet){wxLogMessage("No Pdf is Loaded"); return;}

    char *Pdfpath;
    std::string stlstring = std::string(Location.mb_str());  
    strcpy(Pdfpath, (const char*)stlstring.c_str());
    if(0 == NativeSignAPI::DialogStartSignature((intptr_t)Pdfpath, 1))
    {
        Loglist->Append("DialogStartSignature is Successful");
        PadInDialogMode = true;
    }
    else
    {
        Loglist->Append("DialogStartSignature failed");
    }
    Loglist->SetSelection(Loglist->GetCount() - 1);
}
    //------------------------------------------------------------------------------------------------------------------------------------

void MyFrame::StartSigning()
{
    intptr_t** Acroformfields = NativeSignAPI::GetAcroFormFields();

    size_t length = (size_t)Acroformfields[0];
    bool foundacroform = false;
    for (int k = 1; k <= length; k++) 
    {
        if (GetSignatureFieldByname("SignatureFiled1", Acroformfields[k]))
        {
            Loglist->Append("SignatureFiled found");

            intptr_t DocSignRectanglehandle = NativeSignAPI::GetDocSignRectangleFromTopLeftAndZoomLevel(FirstMouseX, FirstMouseY, 2);
            intptr_t BehaviourDefault = NativeSignAPI::GetBehaviourDefault();
            int32_t error = NativeSignAPI::SetBehaviourSignInDocument(BehaviourDefault, DocSignRectanglehandle, 1);
            // start signature async
            if( 0 == NativeSignAPI::SignSignatureField((intptr_t)Acroformfields[k], NULL, BehaviourDefault))
                Loglist->Append("SignSignatureField started");
            else
                Loglist->Append("SignSignatureField failed");
            
            foundacroform = true;
            break;
        }
    }
    
    if (!foundacroform)
        Loglist->Append("SignatureFiled not found");

    PadInDialogMode = false;

    Loglist->SetSelection(Loglist->GetCount() - 1);
}

bool MyFrame::GetSignatureFieldByname(char* Name, intptr_t* Acroformfield)
{
    if(!NativeSignAPI::GetFieldIsSignatureField((intptr_t)Acroformfield))
        return false;

    std::string str((char*)NativeSignAPI::GetFieldName((intptr_t)Acroformfield));
    std::string str2(Name);
    if(str2 != str)
        return false;

    return true;
}


