#pragma once
// wxWidgets "LoadLicense World" Program
// For compilers that support precompilation, includes "wx/wx.h".
#include <wx/wxprec.h>
#ifndef WX_PRECOMP
    #include <wx/wx.h>
#endif


#include "EventID.h"

  #define STB_IMAGE_IMPLEMENTATION
//#include <stb_image.h>
#include <thread>

#include <stdio.h>

#ifdef _WIN32
    #include <conio.h>
    #include <direct.h>
#else
    #include <curses.h>
    #include <unistd.h>
#endif

#include "ImagePanel.h"
#include <wx/dcclient.h>
#include <wx/graphics.h>
#include <wx/mstream.h>



struct deviceState {
                int32_t IsValid;
                int32_t PadLocked;
                int32_t AdminKeySet;
                int32_t PreDocHashSet;
                int32_t FinalDocHashSet;
                int32_t AesContextSet;
                int32_t Mode;
                int32_t Rotated;
                int32_t RsaSignStatus;
                int32_t ButtonEvent;
                int32_t BatteryState;
                int32_t RotationButtonVisible;
                int32_t Brightness;
                int32_t OpenState;
                int32_t UserScriptExecutionState;
                int32_t ConfigurationState;
                int32_t ErrorFlags;
            };

enum buttonkind {
                unknown,
                rotate,
                next,
                prev,
                ok,
                repeat,
                cancel,
                zoomIn,
                zoomOut,
                startSignature,
                rotate90
            };
            

class MyApp : public wxApp
{
	public:
		virtual bool OnInit();    
};

class MyFrame : public wxFrame
{
public:
    bool IsPdfClientSet;
    bool PadInDialogMode;
    bool FirstMouseDown;
    bool DrawSignatureRectangle;
    bool DrawSignatureRectangleAndStartSignMode;
    long FirstMouseX;
    long FirstMouseY;
    long MouseX;
    long MouseY;
    long SignatureRectangleWidth;
    long SignatureRectangleHeight;
    int CurrentPageNo;
    int MaxPageNo;
    wxListBox *Loglist;
    wxTextCtrl *CurPageNoTxt;
    wxTextCtrl *MaxPageNoTxt;
    wxScrollBar *scrollbar;
    wxString Location;

    MyFrame();
    
    wxMenu *menuSettings;
    wxMenu *DPI_SubMenu;
    static void onButtonEvents(intptr_t* rxptr);
    
  
private:
    
    void OnExit(wxCommandEvent& event);    
    void OnCloseWindow(wxCloseEvent&  event);

    void OnLoadDocument(wxCommandEvent& event);
    void OnSaveDocument(wxCommandEvent& event);
    void OnDPI72(wxCommandEvent& event);
    void OnDPI96(wxCommandEvent& event);
    void OnDPI150(wxCommandEvent& event);
    void OnDPI300(wxCommandEvent& event);
    int GetDPI();

    void OnPanelMouseLeftDn(wxMouseEvent& event);
    void OnPanelMouseLeftUp(wxMouseEvent& event);
    void OnLoadLicenseMouseMove(wxMouseEvent& event);
    bool SelectDevice();
    void EstablishConnectionwithpdfClient();
    void OnScrollBarUpdated(wxCommandEvent& event);

    void OnViewDocument(wxCommandEvent& event);
    void OnAddSignRect(wxCommandEvent& event);
    void OnAddSignRectandStartSignMode(wxCommandEvent& event);
    void OnLoadDialogModeElements(wxCommandEvent& event);
    void OnLoadDialogModeSignature(wxCommandEvent& event);
    void StartSigning();
    bool GetSignatureFieldByname(char* Name, intptr_t* Acroformfield);
    void ViewDocument();
    void DrawCurrentImagetoGUI();
    
};


wxIMPLEMENT_APP(MyApp);
